#ifndef APP_GTC_H
#define APP_GTC_H

#include <QMainWindow>
#include <QSerialPortInfo>
#include <QTime>
#include <QDate>
#include <QString>
#include <iostream>
#include "cserial.h"


using namespace std;

#define SEPARATEUR ';'

namespace Ui {
class app_gtc;
}

class app_gtc : public QMainWindow
{
    Q_OBJECT

public:
    explicit app_gtc(QWidget *parent = 0);
    ~app_gtc();

private:
    int sendCommand();
    char calculChecksum(QByteArray message);
    QStringList listerPorts();
    string resp;

private slots:
    void on_pbConnexion_clicked();
    /*void slotStatusOK();
    void slotConfXbee(QByteArray conf);*/
    void on_receiveData(QByteArray txt);
    void on_erreur(QSerialPort::SerialPortError err);

    void on_cb_segment_stateChanged(int arg1);

    void on_sb_segment_valueChanged(int arg1);

    void on_pb_actuDim_clicked();

    void on_pb_actuInt_clicked();

    void on_pb_horloge_clicked();

    void on_sb_lampadaire_valueChanged(int arg1);

    void on_pb_decalage_clicked();

    //void on_pbConfigurer_clicked();

    void on_pbRefresh_clicked();

private:
    Ui::app_gtc *ui;
    CSerial *port;
    float mAmpere;
    float mWatt;
    QByteArray mAdresse = "1";
    QByteArray mSegment = "1";
    QByteArray mOrdre;
    QByteArray mData;
    QDate mDate;
    QTime mHeure;
};

#endif // APP_GTC_H
