#include "cserial.h"

CSerial::CSerial(QObject *parent, const QString &nomPort)
{
    m_parent = parent;
    m_serial = new QSerialPort(parent);
    m_serial->setPortName(nomPort);
    connect(m_serial, SIGNAL(readyRead()), this, SLOT(onReadyRead())); //connection entre le signal readyRead et le slot onReadyRead
    connect(m_serial, SIGNAL(error(QSerialPort::SerialPortError)), this, SLOT(onErreur(QSerialPort::SerialPortError)));
    qDebug() << "CSerial::L'objet m_Sp du port  " << nomPort << "est créé"; //affichage sur la console de la création du port
}

CSerial::~CSerial()
{
    if(m_serial)
    {
        m_serial->close();
        delete m_serial;
        qDebug() << "L'objet m_serial est détruit est détruit par son destructeur";
    }
}

int CSerial::initialiser(QSerialPort::BaudRate vitesse, QSerialPort::DataBits data, QSerialPort::Parity parity, QSerialPort::StopBits nbStop, QSerialPort::FlowControl flow)
{
    m_serial->setBaudRate(vitesse); // le débit en bauds de la communication
    m_serial->setDataBits(data); //  le nombre de bits de données
    m_serial->setParity(parity); // le schéma de parité utilisé
    m_serial->setStopBits(nbStop); // définit le nombre de bits d'arrêts utilisé
    m_serial->setFlowControl(flow); // définit le contrôle de flux utlisé
    return 0;
}

/*void CSerial::slotLireDonnees()
{

}*/

int CSerial::ouvrirPort()
{
    bool res=false;
    res=m_serial->open(QIODevice::ReadWrite);
    if (!res) {     // si le résultat ne s'ouvre pas
        m_serial->close();
    } // if res
    return m_serial->isOpen();
}

char CSerial::ecrire(const char *trame)
{
    return m_serial->write(trame);
}

void CSerial::onReadyRead()
{
    QByteArray recu;
    recu = m_serial->read(100);
    mRecu.append(recu); //copie du signal reçu
    if(recu.endsWith('\n'))
    {
        emit sigData(mRecu); //emission du signal reçu
        mRecu.clear(); //efface le contenu du signal reçu
    }
}

void CSerial::onErreur(QSerialPort::SerialPortError err)
{
    emit sigErreur(err); //emission du signal sigErreur
}
