#ifndef CSERIAL_H
#define CSERIAL_H

#include <QSerialPort>
#include <QTimer>
#include <QDebug>

#ifndef ERREUR
#define ERREUR (char)-1
#endif
#define OK (char)0
#define TO 3000

class CSerial : public QObject
{
    Q_OBJECT

public:
    explicit CSerial(QObject *parent = 0, const QString &nomPort = "/dev/ttyUSB0");
    ~CSerial();
    int initialiser(QSerialPort::BaudRate vitesse, QSerialPort::DataBits data,
                    QSerialPort::Parity parity, QSerialPort::StopBits nbStop,
                    QSerialPort::FlowControl flow);
    int ouvrirPort();
    char ecrire(const char *trame);
    //void slotLireDonnees();

    /*QString getAction() const;
    void setAction(const QString &action);*/

private:
    QSerialPort *m_serial;
    QObject *m_parent;
    QByteArray mRecu;
    //QString m_action;

signals:
    void sigErreur(QSerialPort::SerialPortError err);
    void sigData(QByteArray ba);
    /*void sigOk();
    void sigConfXbee(QByteArray id);*/

public slots:
    void onReadyRead();
    void onErreur(QSerialPort::SerialPortError err);
};

#endif // CSERIAL_H
