#ifndef CSERIAL_H
#define CSERIAL_H
#include <QObject>
#include <QSerialPort>
#include <QDebug>

class Cserial : public QObject
{
    Q_OBJECT

public:
    explicit Cserial(QObject *parent, const QString &portName = "COM1");
    ~Cserial();
    int ouvrirPort();
    int initialiser(QSerialPort::BaudRate vitesse, QSerialPort::DataBits data,
                    QSerialPort::Parity parity, QSerialPort::StopBits nbStop,
                    QSerialPort::FlowControl flow);

    int ecrire(const char *trame);

    QString getAction() const;
    void setAction(const QString &action);

private:
    QObject *m_parent;
    QSerialPort *m_serial;
    QByteArray m_recu;
    QString m_action;

signals:
    void sigOk();
    void sigError();
    void sigConfXbee(QByteArray id);

public slots:
    void slotLireDonnees();
};

#endif // CSERIAL_H
