#ifndef CSERIAL_H
#define CSERIAL_H

#include <QSerialPort>
#include <QDebug>

#ifndef ERREUR
#define ERREUR (char)-1
#endif
#define OK (char)0
#define TO 5000  // 3s timeout réception

class CSerial : public QObject
{
    Q_OBJECT

public:
    explicit CSerial(QObject *parent = 0, const QString &nomPort = "/dev/ttyUSB0");
    ~CSerial();
    int initialiser(QSerialPort::BaudRate vitesse, QSerialPort::DataBits data,
                    QSerialPort::Parity parity, QSerialPort::StopBits nbStop,
                    QSerialPort::FlowControl flow);
    int ouvrirPort();
    int ecrire(const char *trame);

private:
    QSerialPort *m_Sp;
    QObject *m_parent;
    QByteArray mRecu;


signals:
    void sigErreur(QSerialPort::SerialPortError err);
    void sigData(QByteArray ba);

public slots:
    void onReadyRead();
    void onErreur(QSerialPort::SerialPortError err);
};

#endif // CSERIAL_H
