#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QTimer>
#include <QMainWindow>
#include <QTime>
#include <QDate>
#include <QSerialPortInfo>
#include <QDateTime>
#include <QDebug>
#include <QString>
#include <string>
#include <QJsonArray>
#include <QVariant>
#include <QByteArray>
#include "cserial.h"
#include <QtGlobal>

#define SEPARATEUR ';'

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    bool mXbeeConnected();

private:
    char calculChecksum(QByteArray message);
    int envoyerCommande();
    QStringList listerPorts();

private slots:
    void on_pbConnecterXbee_clicked();
    void on_erreur(QSerialPort::SerialPortError err);
    void on_recevoirDataDuPeriph(QByteArray txt);
//    void on_rbAutomatique_toggled(bool checked);
    void onTimerOut();

//    void on_cbEST_stateChanged(int arg1);

    void on_pbMdp_clicked();

private:
    QTimer *timer;
    Ui::MainWindow *ui;
    QTime mNow;
    QDate mDate;
    float mAmpere;
    float mWatt;
    CSerial *mXbee;
    QByteArray mOrdre;
    QByteArray mAdresse = "1";
    QByteArray mData;
    QByteArray mMode;
    std::string mTime;
    std::string m_respGetted;
    qint64 value;
    std::string mdp = "admin";
};

#endif // MAINWINDOW_H
